# coding: utf8
# author: zmej74
import urllib, sys, os, re, time, shutil
import xbmcaddon, xbmcplugin, xbmcgui, xbmc
import xml.etree.ElementTree as ET
import datetime,  commands
"""
Классы для управления работой эмуляторов
"""


class emu:
    """
    описывает эмулятор и выполняет с ним базовые действия
    """
    def __init__(self):
        self.emu_id = ""
        self.emu_name = ""
        self.emu_version = ""
        self.emu_bin = ""
        self.start_config_path = ""
        self.config_path = ""
        self.start_bin_path = ""
        self.bin_path = ""
        self.log = None
        self.script_start = ""
        self.command = ""
        self.islogout = True

    def logout(self, *messages):
        for message in messages:
            if self.islogout:
                if self.log:
                    print >> self.log, message
                else:
                    print message

    def emu_running(self):
        """
        возвращает True если эму запущен
        """
        try:
            output = commands.getoutput("ps -elf --cols 300 | grep %s | grep -v grep | wc -l" % self.emu_bin)
            result = False if output == "0" else True
        except:
            result = False
        return result

    def emu_start(self):
        """
        запускает эмулятор
        """
        #проверяем папку конфига
        if not os.path.isdir(self.config_path):
            os.makedirs(self.config_path, 0644)
            self.logout("Config dir [ %s ] created." % self.config_path )
        if len(os.listdir( self.config_path )) == 0:
            cmd = "cp %s %s" % (os.path.join(self.start_config_path,"*"), self.config_path)
            os.system( cmd )
            self.logout("Copy config from [ %s ] to [ %s ] done." % (self.start_config_path, self.config_path) )
        #проверяем папку бинарника и если нужно- создаем
        if not os.path.isdir(self.bin_path):
            os.makedirs(self.bin_path, 0755)
            self.logout("Bin dir [ %s ] created." % self.bin_path )
        if not os.path.isfile( os.path.join(self.bin_path, self.emu_bin)):
            shutil.copy(os.path.join(self.start_bin_path,self.emu_bin), os.path.join(self.bin_path, self.emu_bin))
            self.logout("Copy binary[ %s ] from [ %s ] to [ %s ] done." % (self.emu_bin, self.start_bin_path, self.bin_path) )
        #проверяем наличие скрипта автозапуска и если нужно - создаем
        if not os.path.isfile(self.script_start):
            sc = open(self.script_start,  "w")
            print >> sc, "#!/bin/sh"
            print >> sc, self.command
            sc.close()
            self.logout("Start script [ %s ] created." % self.script_start)
        os.chmod(self.script_start,  0755)
        self.logout("Atribute [ %s ] changed." % self.script_start)
        os.chmod( os.path.join(self.bin_path,  self.emu_bin ), 0755 )
        self.logout("Atribute [ %s ] changed." % os.path.join(self.bin_path,  self.emu_bin ) )
        #запускаем
        if not self.emu_running():
            os.system(self.script_start)

    def emu_stop(self):
        """
        останавливает эмулятор - убивает в процессах и удаляет скрипт запуска
        """
        if self.emu_running():
            cmd = "killall -9 %s" % self.emu_bin
            self.logout("Command for stop = %s" % cmd)
            os.system( cmd )
            self.logout("Process [ %s ] stopped." % self.emu_bin)
            # удаляем скрипт автозапуска
            if os.path.isfile(self.script_start):
                os.remove(self.script_start)
                self.logout("Start script [ %s ] deleted." % self.script_start)

    def emu_remove(self):
        """
        удаляет эмулятор - убивает в процессах, удаляет скрипт запуска, удаляет бинарник
        """
        self.emu_stop()
        # удаляем бинарник и папку
        fn = os.path.join(self.bin_path, self.emu_bin)
        if os.path.isfile(fn):
            os.remove(fn)
            self.logout("Binary file [ %s ] deleted." % fn)
        if os.path.isdir(self.bin_path) and len(os.listdir( self.bin_path )) == 0:
            os.removedirs(self.bin_path)
            self.logout("Binary dir [ %s ] deleted." % fn)

class emu_manager:
    """
    класс для управления работой эмуляторов - запуск, остановка, удаление
    """
    def __init__(self):
        self.emus = []
        self.islogout = True
        self.log = None
        self.addonname = ""
        self.addonid = ""
        self.addon = None   #xbmcaddon.Addon(id=__addonid__)
        self.cwd = ""
        self.profile = ""
        self.icondir = ""
        self.language = None    #__addon__.getLocalizedString

    def loadEmus(self):
        self.logout("Begin loading emu.")
        XML_FILE = os.path.join(self.cwd,"resources",'emus.xml')
        self.logout("File: "+XML_FILE + " . Is == "+str(os.path.isfile(XML_FILE)))
        try:
            tree = ET.parse(XML_FILE)
        except:
            self.logout("Error reading xml")
        root = tree.getroot()
        for child_of_root in root:
            # зачитка параметров эмулятора
            oneemu = emu()
            oneemu.emu_id = child_of_root.attrib["emu_id"]
            oneemu.emu_name = child_of_root.attrib["emu_name"]
            oneemu.start_bin_path = child_of_root.attrib["start_bin_path"].replace("$ADDON_PATH",self.cwd)
            oneemu.emu_bin = child_of_root.attrib["emu_bin"]
            oneemu.bin_path = child_of_root.attrib["bin_path"].replace("$ADDON_PATH",self.cwd)
            oneemu.start_config_path = child_of_root.attrib["start_config_path"].replace("$ADDON_PATH",self.cwd)
            onestr = self.readsetting("%s_%s" % (oneemu.emu_id, "ConfigPath"))
            if onestr:
                oneemu.config_path = onestr
            else:
                oneemu.config_path = child_of_root.attrib["config_path"].replace("$ADDON_PATH",self.cwd)
                self.writesetting( "%s_%s" % (oneemu.emu_id, "ConfigPath"), oneemu.config_path)
            """onestr = self.readsetting("%s_%s" % (oneemu.emu_id, "ScriptStart"))
            if onestr:
                oneemu.script_start = onestr
            else:
                oneemu.script_start = child_of_root.attrib["script_start"].replace("$EMU_ID",oneemu.emu_id)
                self.writesetting("%s_%s" % (oneemu.emu_id, "ScriptStart"),oneemu.script_start )
            """
            oneemu.script_start = child_of_root.attrib["script_start"].replace("$EMU_ID",oneemu.emu_id)

            onestr = child_of_root.attrib["command"].replace( "$BIN_NAME", os.path.join( oneemu.bin_path, oneemu.emu_bin) )
            oneemu.command = onestr.replace( "$CONFIG_PATH", oneemu.config_path)
            oneemu.emu_version = child_of_root.attrib["emu_version"]
            oneemu.log = self.log
            self.emus.append( oneemu )
        self.logout("%s Emu descriptions loaded." % len(self.emus))
    def startEmu(self, id_emu):
        for oneemu in self.emus:
            if oneemu.emu_id == id_emu:
                startemu = oneemu
            else:
                oneemu.emu_stop()
        if not startemu.emu_running():
            startemu.emu_start()
            self.showmessage(self.strlanguage(30002,"Start ")+ " " + startemu.emu_name, icon=self.iconname("start.png"))

    def stopEmu(self):
        for oneemu in self.emus:
            oneemu.emu_stop()
            if oneemu.emu_running():
                self.showmessage(self.strlanguage(30004,"Stop ") + " "+  oneemu.emu_name, icon=self.iconname("pause.png"))

    def removeEmu(self):
        if self.showyesno( self.strlanguage(30012,"Remove EMU"), self.strlanguage(30013,"Delete EMU's binary files?"), self.strlanguage(30014,"(configs don't delete)")):
            for oneemu in self.emus:
                oneemu.emu_remove()
            self.showmessage( self.strlanguage(30016, "Remove EMU ") + " ", icon=self.iconname("remove.png"))


    def infoEmu(self):
        running = None
        for oneemu in self.emus:
            if oneemu.emu_running(): running = oneemu
        if running:
             #Addon
            info = self.strlanguage(30006,"EMU") + ": %s \n" % running.emu_name
            #Config path
            info += self.strlanguage(30008,"Config path") + ": %s \n" % running.config_path
            #Status
            info += self.strlanguage(30009,"Status") + ": " + self.strlanguage(30010,"Is started!")
        else:
            info = self.strlanguage(30009,"Status") + ": " + self.strlanguage(30011,"Does not work...")
        self.showOk( self.strlanguage(30005,"EMU Info"), info )

    def infoEcm(self):
        """
        вывод диалогового окна с информацией о ecm
        """
        fname = "/tmp/ecm.info"
        infoecm = {}
        for oneemu in self.emus:
            if oneemu.emu_running():
                sinfo = [""] * 4
                if os.path.isfile(fname):
                    lines = [line.rstrip() for line in open(fname, "r")]
                    if len(lines) > 0:
                        if lines[0][0:2] == "==" and lines[0][-2:] == "==":
                            infoecm = self.EI_wiccard(lines)
                        else:
                            infoecm = self.EI_oscam(lines)
                        sp = " "*2
                        et = infoecm.get("ecm time","").replace("0.","")
                        et = et.replace(".","")
                        sinfo[0] = "caid: " + infoecm.get("caid",""*5) + sp + "ident: "+infoecm.get("prov",""*5)+ sp + "pid: "+ infoecm.get("pid",""*5)
                        sinfo[1] = "chid: " + infoecm.get("chid",""*5)+ sp + "reader: " + infoecm.get("reader",""*10) + sp + "protocol: "+infoecm.get("protocol",""*8)
                        sinfo[2] = "server: " + infoecm.get("from",""*10) + sp + "port: "+infoecm.get("port",""*6) + sp + ("time: %s ms" % et)
                        sinfo[3] = "\ncw0:" + infoecm.get("cw0","") + "  " + "cw1:"+infoecm.get("cw1","")
                        self.showOk( oneemu.emu_name, sinfo[0],sinfo[1],sinfo[2]+sinfo[3])
                    else:
                        self.showOk( oneemu.emu_name, sinfo[0],sinfo[1],sinfo[2]+sinfo[3])
                else:
                    self.showOk( oneemu.emu_name, sinfo[0],sinfo[1],sinfo[2]+sinfo[3])
                break

    def EI_oscam(self,lines):
        """
        парсинг содержимого файла ecm.info эмуляторов Oscam
        """
        info = {}
        try:
            for line in lines:
                s = line.split(":")
                info[s[0].strip()] = s[1].strip()
        except:
            pass
        return info

    def EI_wiccard(self,lines):
        """
        парсинг содержимого файла ecm.info эмуляторов Wicardd/mgcamd
        """
        info = {}
        try:
            info["caid"] = lines[0].split(" on ")[1].split(", ")[0].split("CaID ")[1]
            info["pid"] = lines[0].split("pid ")[1].split(" ")[0]
            info["prov"] = lines[1].split(": ")[1]
            info["cw0"] = lines[2].split(": ")[1].replace(" ","")
            info["cw1"] = lines[3].split(": ")[1].replace(" ","")
            s = lines[5][lines[5].index("(")+1:lines[5].index(")")]
            if " at " in s:
                info["protocol"] = s.split(" at ")[0]
                info["from"] = s.split(" at ")[1].split(":")[0]
                info["port"] = s.split(" at ")[1].split(":")[1]
            else:
                info["from"] = s
            info["ecm time"] = lines[6].split(" ")[0]
        except:
            pass
        return info

    def logout(self, *messages):
        if self.islogout:
            for message in messages:
                if self.log:
                    print >> self.log, message
                else:
                    print message

    def iconname(self,fname):
        """
        возвращает полное имя файла иконки
        """
        return os.path.join(self.cwd, "resources","icons", fname)

    def showmessage(self, message, timewait = 5000, icon=""):
        if not icon: icon = self.iconname("message.png")
        xbmc.executebuiltin("Notification(%s, %s, %d, %s)" % (self.addonname, message, timewait, icon ) )

    def showOk(self, header, str1, str2="", str3=""):
        xbmcgui.Dialog().ok(header, str1, str2, str3)

    def showyesno(self, header, str1, str2="", str3=""):
        return xbmcgui.Dialog().yesno(header, str1, str2, str3)

    def readsetting(self, parname):
        """
        читает параметры аддона
        """
        return self.addon.getSetting(parname)

    def writesetting(self, parname, value):
        """
        сохраняет параметры аддона
        """
        self.addon.setSetting(parname, value)

    def strlanguage(self, id_str, altstr=""):
        onestr = self.addon.getLocalizedString( id_str )
        if onestr:
            return onestr
        else:
            return altstr
